%A demo of the Perona-Malik equation for denoising images
%Author: Jeff Calder, 2016
I = imread('Vincent_Hall_Minnesota_5.jpg');
I = I(1:3:end,1:3:end,:);
I = I(1:end,1:end/2,:);
imshow([I,I]);
u = double(rgb2ycbcr(I));

t = 10; %number of steps between frames
T = 100; %number of frames
eps = 0.5;
lambda = 40;

%add noise
u = u + 30*randn(size(u));
u0 = u;
u2 = ycbcr2rgb(uint8(u));
u0rgb = u2;
pause
imshow([uint8(u2),uint8(u0rgb)]);

pause
for i=1:T
    i
    v = TV_2D(u,u0,eps,lambda,t);
    max(abs(u(:)-v(:)))
    u = v;
    u2 = ycbcr2rgb(uint8(u));
    imshow([uint8(u2),uint8(u0rgb)]);
    drawnow;
end

